/*
  readScratchData example
 
 Checks scratch bank 1 for changes every second.  The LED will blink green
 if any changes are made to bank 1.
 
 <http://www.punchthrough.com/bean> 
 
 */


void setup() 
{
  Serial.begin(57600);
}

bool compareScratch( ScratchData * scratch1, ScratchData * scratch2 )
{
  bool matched = true;
  
  if ( scratch1->length != scratch2->length )
  {
    matched = false;
  }
  else
  {
    int length = min( scratch1->length, scratch2->length );
    int i = 0;
    
    while ( i < length )
    {
      if ( scratch1->data[i] != scratch2->data[i] )
      {
        matched = false;
        i = length;
      }
      i++;
    }
  }
  
    return matched;
}

ScratchData lastScratch;

unsigned char d0,d1;
unsigned char ledR,ledG,ledB;

int8_t newTemp,lastTemp;

// the loop routine runs over and over again forever:
void loop() 
{
  ScratchData thisScratch = Bean.readScratchData(1);
  bool matched = compareScratch( &thisScratch, &lastScratch );
   
  if ( false == matched )
  {
    d0=thisScratch.data[0];
    d1=thisScratch.data[1];
    if(d1&64 || d1&16 || d1&128)
      ledR=255;
    else
      ledR=0;
    
    if(d1&32 || d1&16 || d1&128)
      ledG=255;
    else
      ledG=0;
    
    if(d0&1 || d1&128)
      ledB=255;
    else
      ledB=0;
    
    Bean.setLed(ledR,ledG,ledB);
    lastScratch = thisScratch;
  }
  
  newTemp = Bean.getTemperature();
  if(newTemp!=lastTemp) {
    String ts=String(newTemp, DEC);
    const uint8_t* buf = (const uint8_t*)ts.c_str();
    Bean.setScratchData(2, buf, ts.length());
    lastTemp=newTemp;
  }
  
  Bean.sleep(10);
}
